<script lang="ts" setup>
import type {
  OnActionClickParams,
  VxeTableGridOptions,
} from '#/adapter/vxe-table';
import type { ProjectApi } from '#/api/license/project';

import { Page, useVbenDrawer, useVbenModal } from '@vben/common-ui';
import { downloadFileFromBlobPart } from '@vben/utils';

import { message } from 'ant-design-vue';

import { ACTION_ICON, TableAction, useVbenVxeGrid } from '#/adapter/vxe-table';
import {
  deleteProject,
  exportProject,
  getProjectPage,
} from '#/api/license/project';
import { $t } from '#/locales';

import { useGridColumns, useGridFormSchema } from './data';
import Form from './modules/form.vue';
import ImportForm from './modules/import-form.vue';
import Progress from './modules/progress.vue';

const [FormModal, formModalApi] = useVbenModal({
  connectedComponent: Form,
  destroyOnClose: true,
});

const [ProgressDrawer, progressDrawerApi] = useVbenDrawer({
  connectedComponent: Progress,
  destroyOnClose: true,
});

const [ImportModal, importModalApi] = useVbenModal({
  connectedComponent: ImportForm,
  destroyOnClose: true,
});

/** 刷新表格 */
function onRefresh() {
  gridApi.query();
}

/** 创建项目 */
function onCreate() {
  formModalApi.setData({}).open();
}

/** 编辑项目 */
function onEdit(row: ProjectApi.Project) {
  formModalApi.setData(row).open();
}

/** 项目进展 */
function onProgress(row: ProjectApi.Project) {
  progressDrawerApi.setData(row).open();
}

/** 删除项目 */
async function onDelete(row: ProjectApi.Project) {
  const hideLoading = message.loading({
    content: $t('ui.actionMessage.deleting', [row.name]),
    duration: 0,
    key: 'action_process_msg',
  });
  try {
    await deleteProject(row.id as number);
    hideLoading();
    message.success($t('ui.actionMessage.deleteSuccess', [row.name]));
    onRefresh();
  } catch {
    hideLoading();
  }
}

/** 导出表格 */
async function onExport() {
  const data = await exportProject(await gridApi.formApi.getValues());
  downloadFileFromBlobPart({
    fileName: `${$t('project.project')}.xlsx`,
    source: data,
  });
}

/** 导入项目 */
function handleImport() {
  importModalApi.open();
}

/** 表格操作按钮的回调函数 */
function onActionClick({ code, row }: OnActionClickParams<ProjectApi.Project>) {
  switch (code) {
    case 'delete': {
      onDelete(row);
      break;
    }
    case 'edit': {
      onEdit(row);
      break;
    }
    case 'progress': {
      onProgress(row);
      break;
    }
  }
}

const [Grid, gridApi] = useVbenVxeGrid({
  formOptions: {
    collapsed: true,
    collapsedRows: 2,
    schema: useGridFormSchema(),
    submitOnEnter: true,
  },
  gridOptions: {
    columns: useGridColumns(onActionClick),
    height: 'auto',
    pagerConfig: {
      enabled: true,
    },
    id: 'license-project-list',
    customConfig: {
      storage: true,
    },
    proxyConfig: {
      ajax: {
        query: async ({ page }, formValues) => {
          return await getProjectPage({
            pageNo: page.currentPage,
            pageSize: page.pageSize,
            ...formValues,
          });
        },
      },
    },
    rowConfig: {
      keyField: 'id',
      isHover: true,
    },
    toolbarConfig: {
      refresh: { code: 'query' },
      search: true,
    },
  } as VxeTableGridOptions<ProjectApi.Project>,
});
</script>

<template>
  <Page auto-content-height>
    <FormModal @success="onRefresh" />
    <ProgressDrawer @success="onRefresh" />
    <ImportModal @success="onRefresh" />

    <Grid :table-title="$t('project.list')">
      <template #toolbar-tools>
        <TableAction
          :actions="[
            {
              label: $t('ui.actionTitle.create', [$t('project.project')]),
              type: 'primary',
              icon: ACTION_ICON.ADD,
              auth: ['license:project:create'],
              onClick: onCreate,
            },
            {
              label: $t('ui.actionTitle.export'),
              type: 'primary',
              icon: ACTION_ICON.DOWNLOAD,
              auth: ['license:project:export'],
              onClick: onExport,
            },
            // {
            //   label: $t('ui.actionTitle.import', [$t('project.project')]),
            //   type: 'primary',
            //   icon: ACTION_ICON.UPLOAD,
            //   auth: ['license:project:import'],
            //   onClick: handleImport,
            // },
          ]"
        />
      </template>
    </Grid>
  </Page>
</template>
